unit Unit1;
{ AFDC Ver 1.0  Programmed by AF  1999/06/09 }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls, Menus, StdCtrls, Unit2 ;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    MnuExit: TMenuItem;
    MnuCompare: TMenuItem;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    StringGrid1: TStringGrid;
    Button1: TButton;
    Edit1: TEdit;
    Panel5: TPanel;
    Button2: TButton;
    Edit2: TEdit;
    Panel6: TPanel;
    StringGrid2: TStringGrid;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure MnuExitClick(Sender: TObject);
    procedure MnuCompareClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure StringGrid2DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure StringGrid2DblClick(Sender: TObject);
  private
    { Private 錾 }
	 SGc1,SGc2 : array of Byte ;
	 SGl1,SGl2 : Integer ;
	 function SearchFiles(SGrid:TStringGrid; pn:String):Integer ;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ start }
procedure TForm1.FormShow(Sender: TObject);
begin
	Edit1.Text := '' ;
   Edit2.Text := '' ;
   Panel4.Caption := '' ;
   Panel6.Caption := '' ;
   with StringGrid1 do begin
		Cells[0,0] := 'FileName' ;
      Cells[1,0] := 'Size' ;
      Cells[2,0] := 'DateTime' ;
   end;
   with StringGrid2 do begin
		Cells[0,0] := 'FileName' ;
      Cells[1,0] := 'Size' ;
      Cells[2,0] := 'DateTime' ;
   end;
   SGc1 := nil ;	SGl1 := 0 ;
   SGc2 := nil ;  SGl2 := 0 ;
end;

{ ending }
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   SGc1 := nil ;
   SGc2 := nil ;
end;

{ Browse1 }
procedure TForm1.Button1Click(Sender: TObject);
var i : integer ;
begin
	Form2.ShowModal ;
   if (Form2.OKflag) then begin
   	Edit1.Text := Form2.Path ;
		SGl1 := SearchFiles(StringGrid1, Edit1.Text);
		SGc1 := nil ;
		if (SGl1 = 0) then
			Panel4.Caption := ' No File'
		else begin
			Panel4.Caption := ' ' + IntToStr(SGl1)+' Files' ;
			SetLength(SGc1,SGl1);
			for i:=0 to SGl1-1 do
         	SGc1[i] := 0 ;
		end;
   end;
end;

{ Browse2 }
procedure TForm1.Button2Click(Sender: TObject);
var i : integer ;
begin
	Form2.ShowModal ;
   if (Form2.OKflag) then begin
   	Edit2.Text := Form2.Path ;
		SGl2 := SearchFiles(StringGrid2, Edit2.Text);
		SGc2 := nil ;
		if (SGl2 = 0) then
			Panel6.Caption := ' No File'
		else begin
			Panel6.Caption := ' ' + IntToStr(SGl2)+' Files' ;
			SetLength(SGc2,SGl2);
			for i:=0 to SGl2-1 do
         	SGc2[i] := 0 ;
		end;
   end;
end;

{ Search Files }
function TForm1.SearchFiles(SGrid:TStringGrid; pn:String):Integer ;
var j:Integer ;
	s : String ;
	sr : TSearchRec ;
	ti : TDateTime ;
begin
	j := 0 ;
	if (FindFirst(pn+'*.*',(faReadOnly or faArchive), sr) = 0) then begin
   	s := sr.FindData.cFileName ;
		Inc(j);
		with SGrid do begin
      	Cells[0,j] := s ;
			Cells[1,j] := IntToStr(sr.Size);
			ti := FileDateToDateTime(sr.Time) ;
			ShortdateFormat := 'yyyy/mm/dd';
         s := DateToStr(ti) ;
			LongtimeFormat := 'hh:mm:ss' ;
         Cells[2,j] := s + ' ' + TimeToStr(ti) ;
      end;
   end;
	while (FindNext(sr) = 0) do begin
     	s := sr.FindData.cFileName ;
		Inc(j);
		with SGrid do begin
      	Cells[0,j] := s ;
			Cells[1,j] := IntToStr(sr.Size);
			ti := FileDateToDateTime(sr.Time) ;
			ShortdateFormat := 'yyyy/mm/dd';
         s := DateToStr(ti) ;
			LongtimeFormat := 'hh:mm:ss' ;
         Cells[2,j] := s + ' ' + TimeToStr(ti) ;
      end;
   end;
	FindClose(sr);

	if (j = 0) then begin
   	with SGrid do begin
   		RowCount := 2 ;
         Cells[0,1] := '' ;
         Cells[1,1] := '' ;
         Cells[2,1] := '' ;
		end;
   end
   else begin
   	SGrid.RowCount := j + 1 ;
   end;
	Result := j ;
end;

{ Menu|Exit }
procedure TForm1.MnuExitClick(Sender: TObject);
begin
   close ;
end;

{ Menu|Compare }
procedure TForm1.MnuCompareClick(Sender: TObject);
var i,j,k:Integer ;
   s : String ;
begin
   { check }
   if (Edit1.Text = '')or(Edit2.Text = '') then exit;
   with StringGrid1 do
      if (RowCount = 2)and(Cells[0,1]='') then exit ;
   with StringGrid2 do
      if (RowCount = 2)and(Cells[0,1]='') then exit ;
	if (SGl1 = 0)or(SGl2 = 0) then exit ;
   { StringGrid1 -> StringGrid2 }
   for i:=1 to StringGrid1.RowCount-1 do begin
      s := StringGrid1.Cells[0,i] ;
      k := 0 ;
      for j:=1 to StringGrid2.RowCount-1 do begin
         if (s=StringGrid2.Cells[0,j]) then begin
            k := j ;
            break ;
         end;
      end;
      if (k = 0) then begin
         SGc1[i-1] := 255 ;
      end
      else begin
			if (StringGrid1.Cells[1,i] <> StringGrid2.Cells[1,k]) then
         	SGc1[i-1] := 2 ;
			if (StringGrid1.Cells[2,i] <> StringGrid2.Cells[2,k]) then
         	SGc1[i-1] := SGc1[i-1] or 4 ;
      end;
   end;
   StringGrid1.Refresh ;
   { StringGrid2 -> StringGrid1 }
   for i:=1 to StringGrid2.RowCount-1 do begin
      s := StringGrid2.Cells[0,i] ;
      k := 0 ;
      for j:=1 to StringGrid1.RowCount-1 do begin
         if (s=StringGrid1.Cells[0,j]) then begin
            k := j ;
            break ;
         end;
      end;
      if (k = 0) then begin
         SGc2[i-1] := 255 ;
      end
      else begin
			if (StringGrid2.Cells[1,i] <> StringGrid1.Cells[1,k]) then
         	SGc2[i-1] := 2 ;
			if (StringGrid2.Cells[2,i] <> StringGrid1.Cells[2,k]) then
         	SGc2[i-1] := SGc2[i-1] or 4 ;
      end;
   end;
   StringGrid2.Refresh ;
end;

{ StringGrid1 ColorPaint }
procedure TForm1.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
	if (SGl1 = 0) then exit ;
   if (ARow = 0) then exit ;

   with StringGrid1.Canvas do begin
		Brush.Color := clAqua ;
      Font.Color  := clBlack ;
   	{ no FileName }
	   if (ACol = 0)and((SGc1[ARow-1] and 1) > 0) then begin
			FillRect(Rect);
         TextRect(Rect, Rect.Left+2, Rect.Top+2,
         		StringGrid1.Cells[ACol,ARow]);
		end;
   	{ not Size }
	   if (ACol = 1)and((SGc1[ARow-1] and 2) > 0) then begin
			FillRect(Rect);
         TextRect(Rect, Rect.Left+2, Rect.Top+2,
         		StringGrid1.Cells[ACol,ARow]);
		end;
   	{ not DateTime }
	   if (ACol = 2)and((SGc1[ARow-1] and 4) > 0) then begin
			FillRect(Rect);
         TextRect(Rect, Rect.Left+2, Rect.Top+2,
         		StringGrid1.Cells[ACol,ARow]);
		end;
   end;
end;

{ StringGrid2 ColorPaint }
procedure TForm1.StringGrid2DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
	if (SGl2 = 0) then exit ;
   if (ARow = 0) then exit ;

   with StringGrid2.Canvas do begin
		Brush.Color := clAqua ;
      Font.Color  := clBlack ;
   	{ no FileName }
	   if (ACol = 0)and((SGc2[ARow-1] and 1) > 0) then begin
			FillRect(Rect);
         TextRect(Rect, Rect.Left+2, Rect.Top+2,
         		StringGrid2.Cells[ACol,ARow]);
		end;
   	{ not Size }
	   if (ACol = 1)and((SGc2[ARow-1] and 2) > 0) then begin
			FillRect(Rect);
         TextRect(Rect, Rect.Left+2, Rect.Top+2,
         		StringGrid2.Cells[ACol,ARow]);
		end;
   	{ not DateTime }
	   if (ACol = 2)and((SGc2[ARow-1] and 4) > 0) then begin
			FillRect(Rect);
         TextRect(Rect, Rect.Left+2, Rect.Top+2,
         		StringGrid2.Cells[ACol,ARow]);
		end;
   end;
end;

{ Grid1 select }
procedure TForm1.StringGrid1DblClick(Sender: TObject);
var
	i,j,k : integer ;
   s : String ;
begin
   i := StringGrid1.Row ;
   s := StringGrid1.Cells[0,i] ;
   k := 0 ;
   for j:=1 to StringGrid2.RowCount-1 do begin
      if (s=StringGrid2.Cells[0,j]) then begin
         k := j ;
         break ;
      end;
   end;
   if (k > 0) then begin
		StringGrid2.Row := k ;
   end;
end;

{ Grid2 select }
procedure TForm1.StringGrid2DblClick(Sender: TObject);
var
	i,j,k : integer ;
   s : String ;
begin
   i := StringGrid2.Row ;
   s := StringGrid2.Cells[0,i] ;
   k := 0 ;
   for j:=1 to StringGrid1.RowCount-1 do begin
      if (s=StringGrid1.Cells[0,j]) then begin
         k := j ;
         break ;
      end;
   end;
   if (k > 0) then begin
		StringGrid1.Row := k ;
   end;
end;

end.
